// Auto-generated. Do not edit!

// (in-package osrf_gear.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let Shipment = require('./Shipment.js');

//-----------------------------------------------------------

class ShippingBox {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.shipping_box = null;
      this.shipment = null;
    }
    else {
      if (initObj.hasOwnProperty('shipping_box')) {
        this.shipping_box = initObj.shipping_box
      }
      else {
        this.shipping_box = '';
      }
      if (initObj.hasOwnProperty('shipment')) {
        this.shipment = initObj.shipment
      }
      else {
        this.shipment = new Shipment();
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ShippingBox
    // Serialize message field [shipping_box]
    bufferOffset = _serializer.string(obj.shipping_box, buffer, bufferOffset);
    // Serialize message field [shipment]
    bufferOffset = Shipment.serialize(obj.shipment, buffer, bufferOffset);
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ShippingBox
    let len;
    let data = new ShippingBox(null);
    // Deserialize message field [shipping_box]
    data.shipping_box = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [shipment]
    data.shipment = Shipment.deserialize(buffer, bufferOffset);
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.shipping_box.length;
    length += Shipment.getMessageSize(object.shipment);
    return length + 4;
  }

  static datatype() {
    // Returns string type for a message object
    return 'osrf_gear/ShippingBox';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '53782ca48920c2015fda721bf54da752';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # ShippingBox message
    # This structure contains the information of a shipping box.
    
    # The ID of the shipping box
    string shipping_box
    
    # The shipment on the shipping box
    Shipment shipment
    
    ================================================================================
    MSG: osrf_gear/Shipment
    # Shipment message
    # This structure contains the information of shipment.
    
    # The type of shipment
    string shipment_type
    
    # Collection of products
    Product[] products
    
    ================================================================================
    MSG: osrf_gear/Product
    # Product message
    # This structure contains the information of an product contained in a shipment.
    
    # Product type
    string type
    
    # Target pose
    geometry_msgs/Pose pose
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ShippingBox(null);
    if (msg.shipping_box !== undefined) {
      resolved.shipping_box = msg.shipping_box;
    }
    else {
      resolved.shipping_box = ''
    }

    if (msg.shipment !== undefined) {
      resolved.shipment = Shipment.Resolve(msg.shipment)
    }
    else {
      resolved.shipment = new Shipment()
    }

    return resolved;
    }
};

module.exports = ShippingBox;
