// Auto-generated. Do not edit!

// (in-package osrf_gear.msg)


"use strict";

const _serializer = _ros_msg_utils.Serialize;
const _arraySerializer = _serializer.Array;
const _deserializer = _ros_msg_utils.Deserialize;
const _arrayDeserializer = _deserializer.Array;
const _finder = _ros_msg_utils.Find;
const _getByteLength = _ros_msg_utils.getByteLength;
let DetectedProduct = require('./DetectedProduct.js');

//-----------------------------------------------------------

class ShippingBoxContents {
  constructor(initObj={}) {
    if (initObj === null) {
      // initObj === null is a special case for deserialization where we don't initialize fields
      this.shipping_box = null;
      this.products = null;
    }
    else {
      if (initObj.hasOwnProperty('shipping_box')) {
        this.shipping_box = initObj.shipping_box
      }
      else {
        this.shipping_box = '';
      }
      if (initObj.hasOwnProperty('products')) {
        this.products = initObj.products
      }
      else {
        this.products = [];
      }
    }
  }

  static serialize(obj, buffer, bufferOffset) {
    // Serializes a message object of type ShippingBoxContents
    // Serialize message field [shipping_box]
    bufferOffset = _serializer.string(obj.shipping_box, buffer, bufferOffset);
    // Serialize message field [products]
    // Serialize the length for message field [products]
    bufferOffset = _serializer.uint32(obj.products.length, buffer, bufferOffset);
    obj.products.forEach((val) => {
      bufferOffset = DetectedProduct.serialize(val, buffer, bufferOffset);
    });
    return bufferOffset;
  }

  static deserialize(buffer, bufferOffset=[0]) {
    //deserializes a message object of type ShippingBoxContents
    let len;
    let data = new ShippingBoxContents(null);
    // Deserialize message field [shipping_box]
    data.shipping_box = _deserializer.string(buffer, bufferOffset);
    // Deserialize message field [products]
    // Deserialize array length for message field [products]
    len = _deserializer.uint32(buffer, bufferOffset);
    data.products = new Array(len);
    for (let i = 0; i < len; ++i) {
      data.products[i] = DetectedProduct.deserialize(buffer, bufferOffset)
    }
    return data;
  }

  static getMessageSize(object) {
    let length = 0;
    length += object.shipping_box.length;
    object.products.forEach((val) => {
      length += DetectedProduct.getMessageSize(val);
    });
    return length + 8;
  }

  static datatype() {
    // Returns string type for a message object
    return 'osrf_gear/ShippingBoxContents';
  }

  static md5sum() {
    //Returns md5sum for a message object
    return '84e32b7066f69c6919d8d27ea7fea923';
  }

  static messageDefinition() {
    // Returns full string definition for message
    return `
    # Shipping box contents message
    # This structure contains the information of the current contents of a shipping_box.
    
    # The ID of the shipping_box
    string shipping_box
    
    # Collection of products
    DetectedProduct[] products
    
    ================================================================================
    MSG: osrf_gear/DetectedProduct
    # DetectedProduct message
    # This structure contains the information of a detected product.
    
    # Product type
    string type
    
    # Whether or not the product is faulty
    bool is_faulty
    
    # Target pose
    geometry_msgs/Pose pose
    
    ================================================================================
    MSG: geometry_msgs/Pose
    # A representation of pose in free space, composed of position and orientation. 
    Point position
    Quaternion orientation
    
    ================================================================================
    MSG: geometry_msgs/Point
    # This contains the position of a point in free space
    float64 x
    float64 y
    float64 z
    
    ================================================================================
    MSG: geometry_msgs/Quaternion
    # This represents an orientation in free space in quaternion form.
    
    float64 x
    float64 y
    float64 z
    float64 w
    
    `;
  }

  static Resolve(msg) {
    // deep-construct a valid message object instance of whatever was passed in
    if (typeof msg !== 'object' || msg === null) {
      msg = {};
    }
    const resolved = new ShippingBoxContents(null);
    if (msg.shipping_box !== undefined) {
      resolved.shipping_box = msg.shipping_box;
    }
    else {
      resolved.shipping_box = ''
    }

    if (msg.products !== undefined) {
      resolved.products = new Array(msg.products.length);
      for (let i = 0; i < resolved.products.length; ++i) {
        resolved.products[i] = DetectedProduct.Resolve(msg.products[i]);
      }
    }
    else {
      resolved.products = []
    }

    return resolved;
    }
};

module.exports = ShippingBoxContents;
